@use "@/theme/base.scss";
@use "@/components/Player/Link/theme.module.scss" as player;

$group-round-table-width: 450px;

.groupGrid {
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(calc($group-round-table-width + 2rem), 1fr));
  gap: var(--spacing);
  > article {
    border: var(--border-width) solid var(--muted-border-color);
  }
}

.groupTable {
  --block-spacing-vertical: var(--spacing);
  --block-spacing-horizontal: var(--spacing);
}

.roundRobin h2 {
  display: none;
}

.groupRoundTables {
  display: grid;
  margin: 0;
  grid-template-columns: repeat(auto-fit, minmax($group-round-table-width, 1fr));
  gap: var(--spacing);
  padding: 0;
}

.groupRound {
  @include base.elevated-box;
  // background: var(--box-background-color);
  display: block;
  border-radius: var(--border-radius);
  border: var(--border-width) solid var(--muted-border-color);
  margin: 0;
}

.groupGrid > article > .groupRoundTables {
  gap: 0;
  margin: calc(-1 * var(--block-spacing-vertical) - 1px)
    calc(-1 * var(--block-spacing-horizontal) - 1px);
  > .groupRound,
  .groupRound > header {
    border-radius: 0;
  }
}

.groupRoundTable {
  display: flex;
  flex-direction: column;
}

.groupNo {
  color: var(--color);
  margin: 0;
}

a.groupMatchRow:hover {
  box-shadow: var(--box-shadow);
}

a.groupMatchRow:focus {
  background: var(--primary-focus);
}

@mixin cell {
  padding: calc(var(--spacing) / 2) var(--spacing);
}

.groupMatchRow {
  display: grid;
  grid: "name high-signup high-avatar high-score low-score low-avatar low-signup" / 50px 1fr 32px 50px 50px 32px 1fr;
  gap: 0;
  align-items: stretch;
  transition: var(--transition) background-color, var(--transition) box-shadow;
  box-shadow: 0 0 0 0 rgba(0, 0, 0, 0);
  text-decoration: none;
  color: inherit !important;

  &:nth-child(odd) {
    background-color: var(--table-row-stripped-background-color);
  }

  &:not(:last-child) {
    border-bottom: var(--border-width) solid var(--table-border-color);
  }

  > .matchName {
    @include cell;
    justify-self: center;
    color: var(--bright);
    display: flex;
    justify-content: center;
    align-items: center;
  }

  .score {
    @include cell;
    display: flex;
    justify-content: center;
    align-items: center;
    &.high {
      grid-area: high-score;
    }
    &.low {
      grid-area: low-score;
    }
  }

  .avatar {
    --avatar-size: 32px;
    align-self: center;
    &.high {
      grid-area: high-avatar;
    }
    &.low {
      grid-area: low-avatar;
    }
  }

  .signup {
    white-space: nowrap;
    text-overflow: ellipsis;
    overflow: hidden;
    &.high {
      padding-right: 4px;
      grid-area: high-signup;
      text-align: right;
    }
    &.low {
      padding-left: 4px;
      grid-area: low-signup;
      text-align: left;
    }
    @include cell;
  }

  .bye {
    color: var(--muted-color);
    display: flex;
    justify-content: start;
    align-items: center;
    grid-area: low-avatar / span 2;
  }

  &[data-bye="false"] {
    // winner colours, high
    &[data-winner="high"]::before {
      content: "";
      grid-row: 1;
      grid-column-start: high-signup;
      grid-column-end: high-score;
      background: var(--primary-focus);
    }

    // winner colours, low
    &[data-winner="low"]::before {
      content: "";
      grid-row: 1;
      grid-column-start: low-score;
      grid-column-end: low-signup;
      background: var(--primary-focus);
    }

    // loser colours
    &[data-winner="high"] > .low,
    &[data-winner="low"] > .high {
      opacity: 0.66;
    }
  }
}

// .groupMatchRow {
//   // > td:nth-child(1) {
//   //   width: 2rem;
//   //   text-align: center;
//   //   padding: 0;
//   // }

//   // > td:nth-child(3) {
//   //   width: 2rem;
//   // }

//   // > td:nth-child(4) {
//   //   width: 2rem;
//   // }

//   // > td:nth-child(2) {
//   //   padding: calc(var(--spacing) / 2) calc(var(--spacing) / 2);
//   // }

//   // > td:nth-child(5) {
//   //   padding: calc(var(--spacing) / 2) calc(var(--spacing) / 2);
//   // }

//   // winners
//   &[data-winner="high"] > .groupMatchSignup.high,
//   &[data-winner="low"] > .groupMatchSignup.low {
//   }

//   // losers
//   &[data-winner="high"] > .groupMatchSignup.low,
//   &[data-winner="low"] > .groupMatchSignup.high {
//     opacity: 0.66;
//   }

//   .groupMatchSignup.high {
//     @include player.playerLinkInline(left);
//   }

//   .groupMatchSignup.low {
//     @include player.playerLinkInline(right);
//   }

//   .matchName {
//     color: var(--bright);
//   }
// }

// .groupMatchSignup0 {
//   text-align: right;
// }

// .groupMatchSignup1 {
//   text-align: left;
// }

// .groupMatchSignup0,
// .groupMatchSignup1 {
//   word-break: break-all;
//   text-overflow: ellipsis;
//   overflow: hidden;
//   white-space: pre;
//   max-width: 100px;
// }

// .groupMatchScore0,
// .groupMatchScore1 {
//   text-align: center;
// }
